'filter.inc
'Beinhaltet die Filter




proc Graustufen
parameters startx%,starty%,endx%,endy%

declare x%,y%
declare r%,g%,b%

let x%=startx%
let y%=starty%
let endx%=@add(startx%,endx%)
let endy%=@add(starty%,endy%)

 while @Lt(y%,endy%)
  while @Lt(x%,endx%)
   let r%=@div&(@add(@add(@GetRValue(@GetPixel(x%,y%)),@GetGValue( \
                @GetPixel(x%,y%))),@GetBValue(@GetPixel(x%,y%))),3)
   let g%=r%
   let b%=g%
   SetPixel x%,y%,@RGB(r%,g%,b%)
   inc x%
  wend
  let x%=startx%
  inc y%
 wend

endproc

proc Weichzeichnen
parameters startx%,starty%,endx%,endy%

declare x%,y%
declare r%,g%,b%

let x%=startx%
let y%=starty%
let endx%=@sub(@add(startx%,endx%),1)
let endy%=@sub(@add(starty%,endy%),1)

while @Lt(y%,endy%)
  while @Lt(x%,endx%)
   let r%=@div&(@add(@add(@GetRValue(@getPixel(x%,y%)),@GetRValue(@getPixel(@add(x%,1),y%))), \
              @GetRValue(@getPixel(x%,@add(y%,1)))),3)
   let g%=@div&(@add(@add(@GetGValue(@getPixel(x%,y%)),@GetGValue(@getPixel(@add(x%,1),y%))), \
              @GetGValue(@getPixel(x%,@add(y%,1)))),3)
   let b%=@div&(@add(@add(@GetBValue(@getPixel(x%,y%)),@GetBValue(@getPixel(@add(x%,1),y%))), \
              @GetBValue(@getPixel(x%,@add(y%,1)))),3)
   SetPixel x%,y%,@RGB(r%,g%,b%)
   inc x%
  wend
  let x%=startx%
  inc y%
 wend

endproc

proc Stark_Weichzeichnen
parameters startx%,starty%,endx%,endy%

declare x%,y%
declare r%,g%,b%
declare value1%,value2%,value3%,value4%,value5%

let x%=@add(startx%,1)
let y%=@add(starty%,1)
let endx%=@sub(@add(startx%,endx%),1)
let endy%=@sub(@add(starty%,endy%),1)

while @Lt(y%,endy%)
  while @Lt(x%,endx%)
    let value1%=@getRValue(@GetPixel(x%,y%))
    let value2%=@getRValue(@GetPixel(@add(x%,1),y%))
    let value3%=@getRValue(@GetPixel(x%,@add(y%,1)))
    let value4%=@getRValue(@getPixel(@sub(x%,1),y%))
    let value5%=@getRValue(@getPixel(x%,@sub(y%,1)))
   let r%=@div&(@add(@add(@add(value1%,value2%),@add(value3%,value4%)),value5%),5)
    let value1%=@getGValue(@GetPixel(x%,y%))
    let value2%=@getGValue(@GetPixel(@add(x%,1),y%))
    let value3%=@getGValue(@GetPixel(x%,@add(y%,1)))
    let value4%=@getGValue(@getPixel(@sub(x%,1),y%))
    let value5%=@getGValue(@getPixel(x%,@sub(y%,1)))
   let g%=@div&(@add(@add(@add(value1%,value2%),@add(value3%,value4%)),value5%),5)
    let value1%=@getBValue(@GetPixel(x%,y%))
    let value2%=@getBValue(@GetPixel(@add(x%,1),y%))
    let value3%=@getBValue(@GetPixel(x%,@add(y%,1)))
    let value4%=@getBValue(@getPixel(@sub(x%,1),y%))
    let value5%=@getBValue(@getPixel(x%,@sub(y%,1)))
   let b%=@div&(@add(@add(@add(value1%,value2%),@add(value3%,value4%)),value5%),5)
   
   SetPixel x%,y%,@RGB(r%,g%,b%)
   inc x%
  wend
  let x%=startx%
  inc y%
 wend

endproc

proc Halbton
parameters startx%,starty%,endx%,endy%

declare x%,y%
declare color%

let x%=startx%
let y%=starty%
let endx%=@add(startx%,endx%)
let endy%=@add(starty%,endy%)

 while @Lt(y%,endy%)
  while @Lt(x%,endx%)
   let color%=@div&(@add(@add(@GetRValue(@GetPixel(x%,y%)),@GetGValue( \
              @GetPixel(x%,y%))),@GetBValue(@GetPixel(x%,y%))),3)

   case @equ(color%,@div&(255,2)) : let color%=@RGB(255,255,255)
   case @Lt(color%,@div&(255,2))  : let color%=@RGB(0,0,0)
   case @Gt(color%,@div&(255,2))  : let color%=@RGB(255,255,255)

   SetPixel x%,y%,color%
   inc x%
  wend
  let x%=startx%
  inc y%
 wend

endproc
